<?php
/**************************************************************************\
* eGroupWare - XML-RPC Test App                                            *
* http://www.egroupware.org                                                *
* --------------------------------------------                             *
*  This program is free software; you can redistribute it and/or modify it *
*  under the terms of the GNU General Public License as published by the   *
*  Free Software Foundation; either version 2 of the License, or (at your  *
*  option) any later version.                                              *
\**************************************************************************/

/* $Id: egw_test.php 21274 2006-04-08 14:21:48Z  $ */

	$GLOBALS['egw_info'] = array();
	$GLOBALS['egw_info']['flags'] = array(
		'currentapp'  => 'xmlrpc',
		'noheader'    => False,
		'noappheader' => False,
		'nonavbar'    => False
	);

	include('../header.inc.php');

	$method = get_var('method',array('POST'),'system.listMethods');
	$param = get_var('param',array('POST'));
	$type = get_var('type',array('POST'));
	
	echo '
<form action="' . $GLOBALS['egw']->link('/xmlrpc/egw_test.php') . '" method="post">
<input name="method" VALUE="' . $method . '">
<input name="param" VALUE="' . $param . '">
<select name="type">
<option value="">no param</option>
';
	foreach($GLOBALS['xmlrpcTypes'] as $label => $t)
	{
		if ($t == 1) echo '<option value="'.$label.'"'.($label == $type ? ' selected="1"' : '').'>'.$label."</option>\n";
	}
	echo '</select>
<input type="submit" value="go" name="submit">
</form>
<p>
Enter a method to execute, one parameter and it\'s type';

	if ($_POST['method'])
	{
		$f = CreateObject('phpgwapi.xmlrpcmsg',$method,$_POST['type'] ? array(
			CreateObject('phpgwapi.xmlrpcval',$_POST['type'] == 'INT' ? (int) $_POST['param'] : $_POST['param'], $_POST['type'])
		) : array());
		print '<pre style="text-align: left;">' . htmlentities($f->serialize()) . "</pre>\n";
		$xmlrpc = eregi_replace('https*://[^/]*/','',$GLOBALS['egw_info']['server']['webserver_url']).'/xmlrpc.php';
			
		$c = CreateObject('phpgwapi.xmlrpc_client',$xmlrpc,$_SERVER['HTTP_HOST'],80);
		$c->setDebug(1);
		$r = $c->send($f);
		if (!$r)
		{
			die('send failed');
		}
		$v = $r->value();
		if ($r->faultCode())
		{
			print 'Fault: ';
			print 'Code: ' . $r->faultCode() . " Reason '" .$r->faultString()."'<br>";
		}
	}

	$GLOBALS['egw']->common->egw_footer();
?>
